if not Watcher then return end

local L = LibStub("AceLocale-3.0"):GetLocale("Watcher")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
local C = Watcher.constants -- Defined in Watcher LUA no locale needed.


	function Watcher:expires(expiresin, dotthreshold, typedot, typeShortDot, buffproc, count, countreq)
		if buffproc and expiresin > 0 then
			return true
		elseif count < countreq  and expiresin > dotthreshold then
			return true	
		elseif typeShortDot and expiresin > dotthreshold then
			return true
		elseif typedot and expiresin > dotthreshold then
			return true
		end
			return false
	end

	function Watcher:countcheck(count, countreq, timeleft, buffproc)

		if countreq == 0 or countreq == 1 then
			return true
		elseif count < countreq  and not buffproc or timeleft > 0 then
			return true
		elseif count >= countreq or timeleft > 0 then
			return true
		end
		return false
	end

	function Watcher:Power(power, powerthreshold, negthreshold)
	if not negthreshold then
	return power >= powerthreshold
	end
	return power <= powerthreshold
	end
	
	function Watcher:Health(k)
	local def = self.db.char.spell
	if not def.negHealthThreshold[k] then
		return Watcher.health <= (def.healthThreshold[k]/100)
	end
		return Watcher.health >= (def.healthThreshold[k]/100)
	end
	
	
	function Watcher:UpdateSpell(FrameName, optionnum, k)--, typedot, dotfunction, typeShortDot, shortDotTime, usehealthpc, SpellName, powerthreshold, countreq, dotthreshold, combocost, isproc, findcount, negthreshold, noCD) 
		local def = self.db.char.spell
		--local usable = IsUsableSpell(SpellName)
		local expiresin
		
		local Count = 0
		local powerthreshold = def.powerthresh[k]/100
		--if def.combocost == nil then combocost = 0 end
		local buffproc = true
		local typeaura = false
	--	if def.typeshortdot[k] then
	--		self:Print(def.name[k])
	--	end
		if def.typedot[k] and def.isproc[k] then
			buffproc, Count = Watcher:BuffInfo(k)--, self.db.char.spell.trackspell[k], self.db.char.spell.nocd[k],self.db.char.spell.isbuff[k])
			self:Print(Count)
			Count = Watcher:CountInfo(k)
		elseif def.typedot[k] and not def.typeshortdot[k] then
			expiresin, Count = self:BuffInfo(k)
			self:Print(Count)
			if Count == nil then 
				Count = self:CountInfo(k) or 0 
			end
			if expiresin == true then
				typeaura = true
				if typeaura then
				end
			end
		elseif def.typeshortdot[k] then
			expiresin = Watcher.dottime[k] - GetTime()
			Count = 0
		else
			expiresin = 0
			Count = 0
		end
		local start, duration = GetSpellCooldown(def.spellname[k])
		if start == nil then
		start = 0
		duration = 0
		end
		if Watcher:bossmob(optionnum) and not typeaura and buffproc and ((Watcher:Power(Watcher.power, powerthreshold, def.negthreshold[k]) and def.nocd[k]) or not def.nocd[k] ) and Count >= def.countreq[k] then
			local usable
			if def.spellID[k] ~= nil then
				usable = IsUsableSpell(def.spellID[k])
			else 
				usable = IsUsableSpell(def.spellname[k])
			end
			local timeleft = start + duration - GetTime()
			if not def.isproc[k] and not def.nocd[k] then 
				if timeleft < expiresin and not def.isproc[k] and not def.nocd[k] then
					timeleft = expiresin
				end
			end
		
			
			if timeleft <= self:DotThreshold(k) then timeleft = 0 
			else timeleft = timeleft - self:DotThreshold(k) end
			
			
			if (UnitCastingInfo("player")) and (select(6, UnitCastingInfo("player"))/1000-GetTime()) > timeleft then
				timeleft = (select(6, UnitCastingInfo("player"))/1000-GetTime())
		
			end
			
			
			if timeleft <= 0 then 
				timeleft = 0
				FrameName.Text:Hide()
				
			elseif Watcher.db.char.priority.textshow then
				FrameName.Text:SetText(Watcher:DurationString(timeleft))
				FrameName.Text:Show()
			end
			
			
			Watcher.timeLeft[optionnum] = timeleft
			Watcher.timeLeft[optionnum+self.db.char.priority.num] = timeleft
			
			if not FrameName.play and timeleft > 1.5 then
				FrameName.play = true
			end
			if timeleft > self.db.char.indices[table.getn(self.db.char.indices)]then
				
				FrameName:SetAlpha(0)
				Watcher.timeLeft[optionnum] = -1
				Watcher.timeLeft[optionnum+self.db.char.priority.num] = -1
				return
			end
			
			if usable == 1 and Watcher:Power(Watcher.power, powerthreshold, def.negthreshold[k]) and Watcher:Health(k) and Watcher.combo >= def.combocost[k] then
				if timeleft == 0 then 
					local place = self:findStackPlace(timeleft, optionnum, k)
					if FrameName.play and place == 0 then
						self:Play(FrameName)
						FrameName.play = false
					end
				end
				Watcher.timeLeft[optionnum+self.db.char.priority.num] = -1
				Watcher:MoveIcon(FrameName, timeleft, optionnum)
				
				Watcher:ColorFrame(FrameName)
			else 
				
				Watcher.timeLeft[optionnum] = -1
				Watcher:MoveIcon(FrameName, timeleft, optionnum+self.db.char.priority.num)
				if timeleft == 0 then FrameName.play = true end
				Watcher:ColorUFrame(FrameName)
				
			end
			
			
			return
		end 
		FrameName:SetAlpha(0)
		if self.db.char.showbars then
			FrameName.statusbar:SetAlpha(0)
		end
		Watcher.timeLeft[optionnum] = -1
		Watcher.timeLeft[optionnum+self.db.char.priority.num] = -1
	end
	
	function Watcher:findStackPlace(timeleft, optionnum, k)
		local def = self.db.char.spell
		local place = 0
		if self.db.char.stackmoving or timeleft <= 0 and optionnum > 2 then
			for i = 2, optionnum - 1 do
				if Watcher.timeLeft[i] >= 0 then
					if ((timeleft) - Watcher.timeLeft[i]) >= -1.5 and ((timeleft) - Watcher.timeLeft[i]) <=1.50 then
						place = place + 1
					--	self:Print(Watcher.timeLeft[i], i)
					end
				end
			end
		end

	--	self:Print(place, optionnum)
		return place
	end
	
	
	function Watcher:MoveIcon(FrameName, timeleft, optionnum)
		
		local Offset = self:findStackPlace(timeleft, optionnum, k)
		
		FrameName:SetFrameLevel(self.db.char.priority.num*30- ((optionnum-1)*10))
		if self.db.char.showbars then
			local movingprio = 0
			local movingnum = 0
			for i=2, self.db.char.priority.num do
				if Watcher.timeLeft[i] > 1.5 then movingnum = movingnum + 1 end
			end
			for i=optionnum, self.db.char.priority.num do
				if Watcher.timeLeft[i] > 1.5 then movingprio = movingprio + 1 end
			end
			if timeleft <= 1.5 then
				FrameName.statusbar:SetAlpha(0)
			else
				FrameName.statusbar:SetAlpha(self.db.char.baralpha)
			end
			local offset
			if timeleft <= self.db.char.priority.maxtime then
				offset = timeleft
			else
				offset = self.db.char.priority.maxtime
			end
			FrameName.statusbar:ClearAllPoints()	
			if self.db.char.growdir == "left" or self.db.char.growdir == "right" then
				FrameName.statusbar:SetWidth(offset*Watcher.db.char.priority.IconSize/1.5)
				FrameName.statusbar:SetHeight(Watcher.db.char.priority.IconSize/movingnum)
				FrameName.statusbar:SetPoint("BOTTOMLEFT", self.PriorityFrame, "BOTTOMLEFT", self.db.char.priority.IconSize, self.db.char.priority.IconSize*(movingnum-movingprio)/movingnum)
			else
				FrameName.statusbar:SetWidth(Watcher.db.char.priority.IconSize/movingnum - 1)
				FrameName.statusbar:SetHeight(offset*Watcher.db.char.priority.IconSize/1.5)
				FrameName.statusbar:SetPoint("BOTTOMLEFT", self.PriorityFrame, "BOTTOMLEFT", -self.db.char.priority.IconSize*(movingnum-movingprio)/movingnum, self.db.char.priority.IconSize)
			end
		end
		local stackPos = (Watcher.db.char.priority.IconSize * 0.2) * (Offset)
		local barPos = self:LogPosition(timeleft)
		if self.db.char.growdir == "up" then 
			FrameName:SetPoint("BOTTOMRIGHT", Watcher.PriorityFrame, "BOTTOMRIGHT",  -stackPos , barPos)
		elseif self.db.char.growdir == "down" then 
			FrameName:SetPoint("TOPLEFT", Watcher.PriorityFrame, "TOPLEFT",  -stackPos , -barPos)
		elseif self.db.char.growdir == "right" then 
			FrameName:SetPoint("BOTTOMLEFT", Watcher.PriorityFrame, "BOTTOMLEFT",  barPos , stackPos)
		elseif self.db.char.growdir == "left" then 
			FrameName:SetPoint("BOTTOMRIGHT", Watcher.PriorityFrame, "BOTTOMRIGHT",  -barPos, stackPos)
		end
	end
	
	
	function Watcher:MoveGCD(FrameName, timeleft)
		local stackPos = 0
		local barPos = self:LogPosition(timeleft)
				if self.db.char.growdir == "up" then 
			FrameName:SetPoint("BOTTOMRIGHT", Watcher.PriorityFrame, "BOTTOMRIGHT",  -stackPos , barPos)
		elseif self.db.char.growdir == "down" then 
			FrameName:SetPoint("TOPLEFT", Watcher.PriorityFrame, "TOPLEFT",  -stackPos , -barPos)
		elseif self.db.char.growdir == "right" then 
			FrameName:SetPoint("BOTTOMLEFT", Watcher.PriorityFrame, "BOTTOMLEFT",  barPos , stackPos)
		elseif self.db.char.growdir == "left" then 
			FrameName:SetPoint("BOTTOMRIGHT", Watcher.PriorityFrame, "BOTTOMRIGHT",  -barPos, stackPos)
		end
	end
	
	function Watcher:LogPosition(timeleft)

	if not self.db.char.logtiming then 
		return
	end
	local indices = self.db.char.indices
	local dist = (Watcher.db.char.priority.fWidth)
	for num = table.getn(indices), 2, -1 do 
			
			if timeleft <= indices[num] and timeleft > indices[num-1] then
				
				local t = timeleft - indices[num-1]
				local i = indices[num] - indices[num-1]
			
				local pos = dist*(num-2) + (t/i)*dist
				
				return pos
			end
	end
	return 0
end


	function Watcher:CountInfo(i)
		local index = 1
		local def = self.db.char.spell
		if def.isbuff[i] then
			while UnitBuff("PLAYER", index) do
				local name, _, _, count, _, _, buffexpires = UnitBuff("PLAYER", index)
				if name == def.trackspell[i] then
					--self:Print(name, trackspell, count)
					return count
				end
				index = index + 1
			end
		else
		while UnitDebuff("TARGET", index) do
			local name, _, _, count, _, dur, buffexpires, caster = UnitDebuff("TARGET", index)
			if name == def.trackspell[i] and Watcher:Caster(i, caster) then
				if count == nil then count = 0 end
				return count
			end
			index = index + 1
		end
	end
	return 0, 0 
	end
	
	--Watcher.auras = {}
	
	function Watcher:getAuraInfo()
		local next = next
		local def = self.db.char.spell
		local auraTimes = {}
		local counts = {}
		
		local auraExists = false
		--if next(Watcher.buffs) then
		for k, v in pairs(Watcher.buffs[key]) do
			local name, _, _, count, _, _, buffexpires = UnitBuff("player", v)
			if name == nil then
				if def.andAuras[key] then
					auraExists = false
				end
			else
			auraExists = true
			end
			if count == nil then
				count = 0
			end 
			Watcher.auraTimes[v] = buffexpires
			Watcher.counts[v] = count
		end
		for k, v in pairs(Watcher.debuffs[key]) do
			local name, _, _, count, _, _, buffexpires = UnitDebuff("targer", v)
			if name == nil then
				if def.andAuras[key] then
					auraExists = false
				end
			else
			auraExists = true
			end
			if count == nil then
				count = 0
			end 
			auraTimes[v] = buffexpires
			counts[v] = count
		end
		local timeleft = 0
		local count = 0
		for k,v in pairs(Watcher.auraTimes)do
			if def.andAuras[key] then
				if v < timeleft then
					timeleft = v
					count = counts[k]
				end
			else
				if v > timeleft then
					timeleft = v
					count = counts[k]
				end
			end
		end
		if def.noCD[key] or def.isproc[key] then
			if auraExists then
				return true, count
			end
			return false, 0
		end
		return timeleft, count
	end
	
	--function 
	
	function Watcher:BuffInfo(i)
		local index = 1
		local def = self.db.char.spell
		if def.isbuff[i] then
			while UnitBuff("PLAYER", index) do
				local name, _, _, count, _, _, buffexpires = UnitBuff("PLAYER", index)
				if name == def.trackspell[i] then
				--	self:Print(name,count)
					if count == nil then 
						count = 0	
					end
					if def.nocd[i] or self.db.char.spell.isproc[i] then
						local bool = true
						---self:Print(count)
						return bool, count
					else
						return (buffexpires - GetTime()), count
					end
				end
				index = index + 1
			end
		else
			while UnitDebuff("TARGET", index) do
				local name, _, _, count, _, dur, buffexpires, caster = UnitDebuff("TARGET", index)
				if name == def.trackspell[i] and Watcher:Caster(i, caster) then
					if count == nil then 
						count = 0	
					end
					if def.nocd[i] or def.isproc[i] then
						local bool = true
						return bool, count
					else
						return buffexpires - GetTime(), count
					end
				end
				index = index + 1
			end
		end
		if def.nocd[i] or def.isproc[i] then 
			return false,0 
		end
		return 0, 0 
	end
	
	function Watcher:Caster(i, caster)
		if self.db.char.spell.caster[i] and caster == "player" then
			return true
		elseif not self.db.char.spell.caster[i] then
			return true
		else 
			return false
		end
	end
	
	
	function Watcher:ColorUFrame(FrameName)
		if self.db.char.icon.hide then FrameName:SetAlpha(0) return end
		if self.db.char.icon.grey then FrameName.texture:SetDesaturated(1) return end
		if FrameName.texture:IsDesaturated() then FrameName.texture:SetDesaturated(nil) end
		FrameName.texture:SetVertexColor(self.db.char.icon.col.r, self.db.char.icon.col.r, self.db.char.icon.col.b, 1)
		FrameName:SetAlpha(self.db.char.icon.col.a)
	end
	
	
	function Watcher:ColorFrame(FrameName)
		FrameName:SetAlpha(1)
		FrameName.texture:SetDesaturated(nil)
		FrameName.texture:SetVertexColor(1,1,1,1)
	end
	
	function Watcher:Play(FrameName)
		FrameName.cdFlash:SetCooldown(0,0)
		--self:Print("Flash")
		FrameName.animGrp:Play()
		
	end
	
	function Watcher:DotThreshold(k)
		
		if self.db.char.spell.dct[i] then
			local castTime
			_, _, _, _, _, _, castTime = self.db.char.spell.spellname[k]
			castTime = castTime * 1000
			return def.dotthreshold[k] + castTime
		end
		return def.dottreshold[k]
	end